      Subroutine ChgVa1(ICurr,IStaCr,ExpR,Mode)

C     Mode ... 0 add/cancel similar terms
C          ... 1 sum up terms differing by 1 bracket in denominator
C          ... 2 cancel terms forming energy delta-function
      Use ModXpr
      Implicit None
      Type(Expression), Dimension(NumExp)    :: ExpR

      Logical DeltaF,Summa,GrTh2,GrTh3

C     Internal arrays
      Integer IStart,ICurr,IStaCr,IEqual,i,ii,jj,Mode,ICuOld
      Integer IType
      COMMON /Type/ IType
      Integer IPrint
      COMMON /Print/ IPrint

C     First find a group of terms of similar nature, i.e., where 
C     cancellation is possible.

      IStart=IStaCr
 21   Continue
      If(Mode.eq.2) then
         Do i=IStart,ICurr
            If(Expr(i)%Exponent%Expi(1)%NumO.gt.0) Cycle
            IStart=i
            Exit
         End Do
      End If

      Do i=IStart+1,ICurr
         If(Mode.eq.0) then
            If(GrTh1(ExpR(IStart),ExpR(i))) then
               IEqual=i-1
               Goto 31
            End If

         Else If(Mode.eq.2) then
C           GrTh2 doesn't take into account exponents
            If(GrTh2(ExpR(IStart),ExpR(i))
     $      .or.Expr(i)%Exponent%Expi(1)%NumO.gt.0) then
               IEqual=i-1
               Goto 31
            End If

         Else If(Mode.eq.1) then
            If(GrTh3(ExpR(IStart),ExpR(i)))   then
               IEqual=i-1
               Goto 31  
            End If
         End If

      End Do
      IEqual=ICurr
 31   Continue
C     We found that terms from IStart to IEqual are of the same type,
C     There is a chance that they would cancel or simplify
C     
      If(IPrint.ge.5) Write(6,*)'IStart,IEqual',IStart,IEqual
      If(IEqual.lt.IStart) goto 41
      If(Mode.eq.1.and.IEqual.eq.IStart) goto 51
      If(IType.eq.4) Goto 51
*****************************************

C     Sum up numerical factors of terms from IStart to IEqual

      If(Mode.eq.0) then
         Do ii=IStart+1,IEqual
            Call AddSim(ExpR(IStart)%IPowr,ExpR(ii)%IPowr)        
         End Do

      Else If(Mode.eq.1) then
         Do ii=IStart,IEqual
            If(ExpR(ii)%IPowr(1).eq.0) Cycle

            Do jj=ii+1,IEqual
               If(ExpR(jj)%IPowr(1).eq.0) Cycle
               If(ExpR(jj)%IPowr(4).ne.ExpR(ii)%IPowr(4)) Cycle
C              We added term jj to term ii. Term jj now can be killed
               If(Summa(ExpR(ii),ExpR(jj))) ExpR(jj)%IPowr(1)=0

C              Skip loop over jj if term ii has been killed as well
               If(ExpR(ii)%IPowr(1).eq.0) Exit
            End Do
         End Do

C     Temporarily disable Mode=2
C      Else If(Mode.eq.2) then
C         Do ii=IStart,IEqual
C            If(ExpR(ii)%IPowr(1).eq.0) Cycle

C            Do jj=ii+1,IEqual
C               If(ExpR(jj)%IPowr(1).eq.0) Cycle
C               If(DeltaF(ExpR(ii),ExpR(jj))) then
CC                 All tests passed: ii and jj form delta-function
CC                 whose argument cannot be zero.

C                  ExpR(ii)%IPowr(1)=0
C                  ExpR(jj)%IPowr(1)=0
C                  Exit
C               End If
C            End Do
C         End Do
      End If
  51  Continue

      IStart=IEqual+1
      If(IStart.le.ICurr) goto 21
  41  Continue

C     Now we should clean up our terms by eliminating those whose 
C     multipliers are zero

      ii=IStaCr-1
C      Write(6,*)'Before elimination, IStaCr,ICurr= ',IStaCr,ICurr
      ICuOld = ICurr
      Do i=IStaCr,ICurr
         If(ExpR(i)%IPowr(1).eq.0) Cycle
         ii=ii+1
         ExpR(ii) = ExpR(i)
         Call Order_Bracket(ExpR(ii)%Denominator,ExpR(ii)%IPowr)
      End Do
      ICurr = ii

      If(Mode.eq.0) then
         Write(6,*) 'Cancellation of terms: before ',IStaCr,ICuOld,
     $   ' after ',ICurr
      Else If(Mode.eq.1) then
         Write(6,*) 'Summation of terms   : before ',IStaCr,ICuOld,
     $   ' after ',ICurr
      Else If(Mode.eq.2) then
         Write(6,*) 'Form delta-functions : before ',IStaCr,ICuOld,
     $   ' after ',ICurr
      End If

      If(IPrint.ge.10) then
         Write(6,*)'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
         Do i=IStaCr,ICurr
            Call Output(6,ExpR(i),'after ChgVa1',i)
         End Do
         Write(6,*)'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
      End If
      Return
      End
