      Subroutine Master(INum,IDen,IPow,FileN1,FileN2,FilOut)
      Use ModXpr 
      Use ModDNT
      Use ModTem
      Implicit None     
      Character*3 KeyWrd
      Character*20 FileN1,FileN2,FilOut

C     Internal arrays
      Type(Expression)                    :: Exp1, Exp2, Exp3, Exp4
      Type(Expression), Dimension(NumExp) :: ExpR 
      Type(Energy) MaShel,Momen1
      Type(Energy) Temp
      Type(Operator) Left,Right,Oper4,B,Form_Oper
      Type(One_Operator) Oper1,ReadOneOperator
      Type(MomExp)                      :: Zero,To,Is
      Type(Momentum) From
      Integer INum,IDen,IPow
      Integer KType,Status,NConn,ii,i,j,ICurr,k,Nmdn,NumTer,IEnd
      Integer ICrOld,ISt,ic
      Integer Kill_Delta,IDummy
      Logical FitTmp, Physic,PhysBr
      Logical Destruction_Operator,Creation_Operator
      Type(List) ListVariablesOp

C    String DoNotT contains momvars labeling momenta of incoming 
C    and outcoming particles.  These momenta should not be touched when
C    changing variables in UVEpdk

      Integer IType
      COMMON /Type/ IType
      Integer IPrint
      COMMON /Print/ IPrint

      Open(15,File=FilOut)
      Close(15,Status='Delete')
      Open(15,File=FilOut)

C     IPrint,     printing parameter 
C             ... -1   output in the input form
C             ... 0-2  minimum output
C             ... 3-8  debug output
C             ... >8   maximum debug output
C     IType,      type of calculation
C             ... 0    commutator of expressions in first.inp and 
C                      second.inp
C             ... 1    sum of expressions in first.inp and second.inp
C                      that are assumed to be already in the normal 
C                      order
C             ... 2    solve equation [?,H0]=i*first.inp
C             ... 3    multiply expression by a constant
C             ... 4    calculate matrix element
C             ... 5    product of two operators

      If(IPrint.ge.3) Write(6,*)'IPrint,IType=',IPrint,IType
C      Write(6,*)'MaxNum in Master= ',MaxNum
C      If(IType.eq.3) then
C         Read(5,*)Inum,IDen
C      End If     
      ICurr=0

      If(IType.eq.0) then
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C           ITYPE = 0   COM
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C        Take commutator of operators in 'first.inp' and 'second.inp'
      Open(10,File=FileN1)
         Open(11,File=FileN2)
         Do i=1,NumExp
C           Reading the first string 
            Call ReadEx(10,Exp1,1,IEnd)    
            If(IEnd.eq.1) Exit
            If(IPrint.ge.0) Write(6,*) 'Finish reading 10'
            Do j=1,NumExp
C              Reading the second string 
               Call ReadEx(11,Exp2,1,IEnd)
               If(IEnd.eq.1) Exit

               If(IPrint.ge.0) Write(6,*) 
     $         'Calculate commttrs of term #',i,'from first.inp'
               If(IPrint.ge.0) Write(6,*) 
     $         'and term #',j,'from second.inp'
               If(IPrint.ge.0) 
     $         Write(6,*) '********************************************'
               If(IPrint.ge.0) Write(6,*) 'ICurr before Commut',ICurr
               ICrOld=ICurr

               Exp4 = Exp1
               Exp3 = Exp2
               Exp3%IPowr(3) = Exp3%IPowr(3) + 2
               Call Produc(ICurr,Exp1,Exp2,ExpR)
               Call Produc(ICurr,Exp3,Exp4,ExpR)

               If(ICurr.lt.ICrOld) ICurr=ICrOld
               If(IPrint.ge.0) Write(6,*) 'ICurr after Commut',ICurr 
            End Do
 200        Rewind 11
         End Do
         Rewind 11
         Close (11)
         Rewind 10
         Close (10)

          If(IPrint.ge.0) Write(6,*) 'Final calculation'
         Call Calclt(ICurr,1,ExpR)

         Call PutFil(ICurr,ExpR)

      Else If(IType.eq.1) then
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C           ITYPE = 1    SUM
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C        Take sum of operators in 'first.inp' and 'second.inp'
      Open(10,File=FileN1)
         Open(11,File=FileN2)
         NumTer=1
         Do i=1,NumExp
C           Reading the first string
            Call ReadEx(10,ExpR(NumTer),1,IEnd)
            If(IEnd.eq.1) Exit
            If(ExpR(NumTer)%IPowr(4).gt.OrderN) Cycle
            NumTer=NumTer+1
         End Do
 110     Continue
         Do i=1,NumExp
C           Reading the second string
            If(NumTer.gt.NumExp)
     $      Write(6,*) 'Warning!! Too many temrs!'
            Call ReadEx(11,ExpR(NumTer),1,IEnd) 
            If(IEnd.eq.1) Exit
            If(ExpR(NumTer)%IPowr(4).gt.OrderN) Cycle
            NumTer=NumTer+1
         End Do
 210     Continue
         ICurr=NumTer-1
         Rewind 11
         Close (11)
         Rewind 10
         Close(10)
          If(IPrint.ge.0) Write(6,*) 'Final calculation'
         Call Calclt(ICurr,1,ExpR)

         Call PutFil(ICurr,ExpR)
      Else If(IType.eq.2) then
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C           ITYPE = 2    SOL
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C        Solve equation [?,H0]='first.inp'
C        DenomR gets a new factor - mass-shell condition
         Open(10,File=FileN1)
         NumTer=0
         Do i=1,NumExp
C           Reading the first string
            Call ReadEx(10,ExpR(i),1,IEnd)
            If(IEnd.eq.1) Exit
            If(IPrint.ge.0) 
     $      Call Output(6,ExpR(i),'Operator after reading',i)
            NumTer=NumTer+1

            Momen1 = MaShel(ExpR(i)%Oper)
            ExpR(i)%Denominator%NumDen= ExpR(i)%Denominator%NumDen+1
            NmDn= ExpR(i)%Denominator%NumDen
            ExpR(i)%Denominator%Denom(NmDn)=Momen1
            ExpR(i)%IPowr(3)=ExpR(i)%IPowr(3)+2

            Call PreDen(ExpR(i)%Denominator,ExpR(i)%IPowr)

         End Do
 120     Continue
         ICurr=NumTer
C        We assume that the terms are already ordered and simplified
         Rewind 10
         Close (10)

         Call PutFil(ICurr,ExpR)
      Else If(IType.eq.3) then
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C           ITYPE = 3    MUL
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C        Multiply 'first.inp' by a number Inum/IDen*(i)**IPow
C         Write(6,*) 'IType= ',IType
         Open(10,File=FileN1)
         NumTer=1
C         Write(6,*)'NumExp= ',NumExp
         Do i=1,NumExp
C           Reading the  string
            Call ReadEx(10,ExpR(NumTer),1,IEnd)
            If(IEnd.eq.1) Exit
            If(ExpR(NumTer)%IPowr(4).gt.OrderN) Cycle
            If(NTempl.gt.0.and.
     $       .not.FitTmp(ExpR(NumTer)%Oper)) Cycle
            ExpR(NumTer)%IPowr(1)=ExpR(NumTer)%IPowr(1)*INum
            ExpR(NumTer)%IPowr(2)=ExpR(NumTer)%IPowr(2)*IDen
            ExpR(NumTer)%IPowr(3)=ExpR(NumTer)%IPowr(3)+IPow
            NumTer=NumTer+1

         End Do
 130     Continue
         ICurr=NumTer-1
C        We assume that the terms are already ordered and simplified
         Rewind 10
         Close (10)
         Call PutFil(ICurr,ExpR)
      Else If(IType.eq.4) then
      
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C           ITYPE = 4    MAT
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C        Take matrix element of operator in FileN1 with states in FileN2
         Open(10,File=FileN1)
         Open(11,File=FileN2)
C        First read in and out vectors in Oper1 and Oper2

         Left%NumOp = 0
         Right%NumOp = 0
         Do i=1,nmaxOp
            Oper1=ReadOneOperator(11,Status)
            If(Status.eq.-1) Exit
            If(Creation_Operator(Oper1)) then
               B=Form_Oper(Oper1)
               Right = Right * B
            Else If(Destruction_Operator(Oper1)) then
               B=Form_Oper(Oper1)
               Left = Left * B
            End If 
         End Do

         DoNotT = ListVariablesOp(Left,'*')
     $   * ListVariablesOp(Right,'*') 
         Rewind 11
         Close (11)

         NumTer=0
         Do i=1,NumExp
C           Reading the operator string
            Call ReadEx(10,Exp3,1,IEnd)
            If(IEnd.eq.1) Exit
            If(IPrint.ge.0) Write(6,*) 'Quit ReadEx'
            NumTer=NumTer+1

            Call SubstituteLabelsExpR(Exp3,'*','$')

            Oper4 = Left * Exp3%Oper
            Exp3%Oper = Oper4 * Right

            ICrOld=ICurr

            Call Normal(ICurr,Exp3,ExpR)
            Call Finalz(ICurr,ICrOld,ExpR)

            If(ICurr.lt.ICrOld) ICurr=ICrOld
         End Do
 710     Continue

         Rewind 10 
         Close(10)
          If(IPrint.ge.0) Write(6,*) 'Final calculation'
         Call Calclt(ICurr,1,ExpR)

         Call PutFil(ICurr,ExpR)

C         Write(6,*)'Exit'
      Else If(IType.eq.5) then
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C           ITYPE = 5   PRO
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C        Take product of operators in 'first.inp' and 'second.inp'
      Open(10,File=FileN1)
         Open(11,File=FileN2)
         Do i=1,NumExp
C           Reading the first string
            Call ReadEx(10,Exp1,1,IEnd)
            If(IEnd.eq.1) Exit
            Do j=1,NumExp
C              Reading the second string
               Call ReadEx(11,Exp2,1,IEnd)
               If(IEnd.eq.1) Exit
               If(IPrint.ge.0) Write(6,*)
     $         'Calculate product of term #',i,'from first.inp'
               If(IPrint.ge.0) Write(6,*)
     $         'and term #',j,'from second.inp'
               If(IPrint.ge.0)
     $         Write(6,*) '********************************************'
               If(IPrint.ge.0) Write(6,*) 'ICurr before Commut',ICurr
               ICrOld=ICurr
               Call Produc(ICurr,Exp1,Exp2,ExpR)

               If(ICurr.lt.ICrOld) ICurr=ICrOld
               If(IPrint.ge.0) Write(6,*) 'ICurr after Commut',ICurr
            End Do
 201        Rewind 11
         End Do
         Rewind 11
         Close (11)
         Rewind 10
         Close(10)

         If(IPrint.ge.9)Write(6,*)'Final Calculation'   
         Call Calclt(ICurr,1,ExpR)

         Call PutFil(ICurr,ExpR)
      Else If(IType.eq.6) then
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C           ITYPE = 6    ENR
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C        Take operators in 'first.inp' on the mass shell
C        ENR is equivalent to integration from -T to T
         Open (10,File=FileN1)
         k=0

         Do i=1,NumExp
C           Reading the string
            Call ReadEx(10,ExpR(k+1),1,IEnd)
            If(IEnd.eq.1) then
               ICurr=k
               Exit
            End If

C           Process delta functions
            k=k+1
C            If(ExpR(k)%Delta%Length.gt.0) IDummy=
C     $      Kill_Delta(ExpR(k),ExpR(k)%Delta,1)

C           Remove terms having no t-dependence
C           Integration of energy exponent would yield delta
C           function. If argument of delta function is unphysical, skip

            If(ExpR(k)%Exponent%Expi(1)%NumO.eq.0) then
               k=k-1
               Cycle
            End If
            If(ExpR(k)%IPowr(4).gt.OrderN) then 
               k=k-1
               Cycle
            End If
            If(.not.Physic(ExpR(k)%Exponent%Expi(1))) then
C              Check if denominator doesn't contain physical brackets
C              Temporarily disable this check
C               Do ii=1,ExpR(k)%Denominator%NumDen
C                  If(Physic(ExpR(k)%Denominator%Denom(ii))) goto 22
C               End Do
               k=k-1
               Cycle
            End If
 22         Continue
         End Do
         Rewind 10
         Close (10)

         Call Calclt(ICurr,1,ExpR)
         Call PutFil(ICurr,ExpR)

      Else If(IType.eq.7) then
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C           ITYPE = 7    DEL
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C        Delete terms according to templates
C         Write(6,*) 'IType= ',IType
         Open (10,File=FileN1)
         NumTer=0
C         Write(6,*)'NumExp= ',NumExp
         Do i=1,NumExp
C           Reading the  string
            NumTer=NumTer+1
            Call ReadEx(10,ExpR(NumTer),1,IEnd)
            If(IEnd.eq.1) then
               NumTer=NumTer-1
               Exit
            End If
            If(FitTmp(ExpR(NumTer)%Oper)) NumTer=NumTer-1

         End Do
         ICurr=NumTer
c        We assume that the terms are already ordered and simplified
         Rewind 10
         Close (10)
         Call PutFil(ICurr,ExpR)
      Else If(IType.eq.8.or.IType.eq.12) then
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C           ITYPE = 8    IN2
C           ITYPE = 12   INT
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C        Integrate term from -T to t (IType=8)
C        Just keep t-term            (IType=12)
         Open (10,File=FileN1)
         NumTer=0
         ii=0
         Do i=1,NumExp
            ii=ii+1
C           Reading the expression to be integrated
            Call ReadEx(10,ExpR(ii),1,IEnd)
            If(IEnd.eq.1) then
               ICurr=ii-1
               Exit
            End If
            If(ExpR(ii)%IPowr(4).gt.OrderN) then
               ii=ii-1
               Cycle
            End If

            If(IPrint.ge.9) 
     $      Call Output(6,ExpR(ii),'Term to be transformed',ii)
            Call Intgrt(ii,ExpR)
         End Do

         Rewind 10
         Close (10)

         Call Calclt(ICurr,1,ExpR)
         Call PutFil(ICurr,ExpR)
      Else If(IType.eq.9) then
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C           ITYPE = 9    CON
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C        Remove unconnected diagrams (after PRO)
C         Write(6,*) 'IType= ',IType
         Open (10,File=FileN1)
         NumTer=0
C         Write(6,*)'NumExp= ',NumExp
         Do i=1,NumExp
C           Reading the  Expression
            Call ReadEx(10,ExpR(NumTer+1),1,IEnd)
            If(IEnd.eq.1) Exit
            If(ExpR(NumTer+1)%IPowr(4).gt.OrderN) Cycle
            Call TypeDg(ExpR(NumTer+1)%Oper,KType,NConn)
            If(NConn.gt.1)Cycle
            NumTer=NumTer+1
         End Do
         ICurr=NumTer
C        We assume that the terms are already ordered and simplified
         Rewind 10
         Close (10)
         Call PutFil(ICurr,ExpR)


      Else If(IType.eq.10) then
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C           ITYPE = 10   INF 
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C        Take time t in 'first.inp' to + infinity (T)
         Open (10,File=FileN1)
         k=0
         Do i=1,NumExp
C           Reading the string
            Call ReadEx(10,ExpR(k+1),1,IEnd)
            If(IEnd.eq.1) then
               ICurr=k
               Exit
            End If

            k=k+1
            If(ExpR(k)%Exponent%Expi(1)%NumO.gt.0) then
               ExpR(k)%Exponent%Expi(2) = 
     $         ExpR(k)%Exponent%Expi(1) + ExpR(k)%Exponent%Expi(2)
               ExpR(k)%Exponent%Expi(1)%NumO = 0
            End If
         End Do

         Rewind 10
         Close (10)

         Call Calclt(ICurr,1,ExpR)

         Call PutFil(ICurr,ExpR)

      Else If(IType.eq.11) then
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C           ITYPE = 11    EN2
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C        Take operators in 'first.inp' on the mass shell
C        ENR is equivalent to integration from -T to T
         Open (10,File=FileN1)
         k=0

         Do i=1,NumExp
C           Reading the string
            Call ReadEx(10,ExpR(k+1),1,IEnd)
            If(IEnd.eq.1) then
               ICurr=k
               Exit
            End If
            If(ExpR(k+1)%IPowr(4).gt.OrderN) Cycle

C           Remove terms having no t-dependence
C           Integration of energy exponent would yield delta
C           function. If argument of delta function is unphysical, skip

            k=k+1
            If((ExpR(k)%Exponent%Expi(1)%NumO.eq.0).or.
     $      ((.not.Physic(ExpR(k)%Exponent%Expi(1))).and.
C           Instead of PhysBr here use the same as in ENR
     $      (.not.PhysBr(ExpR(k)%Denominator)) )) then
               k=k-1
               Cycle
            End If
            Call Intgrt(k,ExpR)

C           In term k-1 substitute t -> T
            Temp = Expr(k-1)%Exponent%Expi(1)
            ExpR(k-1)%Exponent%Expi(2) =
     $      ExpR(k-1)%Exponent%Expi(2) + Temp
            ExpR(k-1)%Exponent%Expi(1)%NumO = 0

         End Do
         Rewind 10
         Close(10)

         Call Calclt(ICurr,1,ExpR)
         Call PutFil(ICurr,ExpR)
      Else If(IType.eq.13) then
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C           ITYPE = 13   DLT
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C        Remove delta functions
         Open (10,File=FileN1)
         k=0
         Do i=1,NumExp
C           Reading the string
            Call ReadEx(10,ExpR(k+1),1,IEnd)
            If(IEnd.eq.1) then
               ICurr=k
               Exit
            End If

            k=k+1
C            If(ExpR(k)%Delta%Length.gt.0) IDummy=
C     $      Kill_Delta(ExpR(k),ExpR(k)%Delta,1)
         End Do

         Rewind 10
         Close (10)

         Call Calclt(ICurr,1,ExpR)
         Call PutFil(ICurr,ExpR)
      End If
      Return
      End

