      Module ModExp
      Use ModEnr
      Implicit None

      Type ExpFunction
         Type(Energy), Dimension(2)  ::  Expi
      End Type ExpFunction

      Interface Operator (*)
         Module Procedure Exponent_Product
      End Interface
      Interface Operator (.grth.)
         Module Procedure Greater_Than_Exp
      End Interface 
      Interface Operator (.equal.)
         Module Procedure Equal_Exp
      End Interface


      Contains
C############################################################       
      Function Exponent_Product(A,B)
C     Form product of two exponential expressions
      Implicit None
      Type(ExpFunction),Intent(In)  :: A,B
      Type(ExpFunction) Exponent_Product

      Exponent_Product%Expi(1) = A%Expi(1) + B%Expi(1)
      Exponent_Product%Expi(2) = A%Expi(2) + B%Expi(2)
      End Function Exponent_Product
C############################################################
      Function Greater_Than_Exp(A,B)
      Implicit None
      Type(ExpFunction),Intent(In)           :: A,B
      Logical                 :: Greater_Than_Exp
      Integer i
      Integer IType
      COMMON /Type/ IType

      Greater_Than_Exp = .false.

      Do i=1,2
C        Disregard t-dependence if we are doing ENR
C         If(IType.eq.6.and.i.eq.1) Cycle
         If(A%Expi(i)%NumO.eq.0.and.B%Expi(i)%NumO.eq.0) Cycle
         If(A%Expi(i) .grth. B%Expi(i)) then
            Greater_Than_Exp = .true.
            Return
         Else If(B%Expi(i) .grth. A%Expi(i)) then
            Return
         End If
      End Do
      End Function Greater_Than_Exp
C############################################################
      Function Equal_Exp(A,B)
      Implicit None
      Type(ExpFunction),Intent(In)        :: A,B
      Logical                 :: Equal_Exp

      Equal_Exp = .false.
      If((.not.(A.grth.B)).and.(.not.(B.grth.A)))
     $Equal_Exp = .true.
      End Function Equal_Exp

C############################################################
      End Module ModExp
