      Module ModGam
      Use ModLet
      Use Md1UVE
      Implicit None
      Integer nmaxGm  

      Parameter(nmaxGm = 20)
      Type Gamma
         Integer                              ::  NumGam
         Type(One_Gamma), Dimension(nmaxGm)   ::  GamG         
      End Type Gamma

      Interface Operator (.grth.)
         Module Procedure Greater_Than_Gamma
      End Interface
      Interface Operator (*)
         Module Procedure Product_Gamma
      End Interface

      Contains
C############################################################
      Function Greater_Than_Gamma(A,B)
      Implicit None
      Type(Gamma),Intent(In)            :: A,B
      Logical                 :: Greater_Than_Gamma
      Integer i

      Greater_Than_Gamma = .false.
      If(A%NumGam.gt.B%NumGam) then
         Greater_Than_Gamma = .true.
         Return
      Else If(A%NumGam.eq.B%NumGam) then
         Do i=1,A%NumGam
            If(A%GamG(i) .grth. B%GamG(i)) then
               Greater_Than_Gamma = .true.
               Return                  
            Else If(B%GamG(i) .grth. A%GamG(i)) then
               Return
            End If
         End Do
      End If
      End Function Greater_Than_Gamma
C############################################################
      Function Product_Gamma(A,B)
      Implicit None
      Type(Gamma),Intent(In)             :: A,B
      Type(Gamma)                 :: Product_Gamma
      Integer i,ii

      Product_Gamma%NumGam = A%NumGam + B%NumGam
      Do i=1,A%NumGam
         Product_Gamma%GamG(i) = A%GamG(i)
      End Do
      Do i=1,B%NumGam
         ii = A%NumGam + i
         Product_Gamma%GamG(ii) = B%GamG(i)
      End Do         
      End Function Product_Gamma
C############################################################
      End Module ModGam
