      Module ModLet

C     This module contains utility routines operating on
C     strings (derived type List)

      Implicit None
      Integer NCh
      Parameter(NCh=200)
      Type List
         Integer                        :: Length
         Character*(NCh)                :: Body
      End Type List

      Interface Operator (.grth.)
         Module Procedure Greater_Than
      End Interface
      Interface Operator (*)
         Module Procedure JoinLists
      End Interface
      Interface Operator (-)
         Module Procedure Delete
      End Interface
      Interface Operator (.equal.)
         Module Procedure List_Equal
      End Interface

      Contains
C############################################################
      Function Greater_Than(A,B)

C     Returns .true. if character A is greater than character B
C     Otherwise returns .false.

      Implicit None
      Character,Intent(In)      :: A,B
      Logical                   :: Greater_Than
      Integer Find_Number

      Greater_Than=.false.
      If(Find_Number(A).gt.Find_Number(B)) Greater_Than=.true.        
      End Function Greater_Than         
C############################################################
      Function JoinLists(A,B)

C     Join together two Lists

      Implicit None
      Type(List),Intent(In)     :: A,B
      Type(List)                :: JoinLists,C

      C%Length = A%Length + B%Length
      If(C%Length.gt.NCh) Write(6,*) 'Warning!!! List too long!'

      C%Body(:A%Length)=A%Body(:A%Length)
      C%Body(A%Length+1:A%Length+B%Length) =B%Body(:B%Length)
      JoinLists = C
      End Function JoinLists

C############################################################
      Function Delete(Momen2,Momen1)
C     Momen1 and Momen2 are lists of characters. Delete from Momen2
C     those characters that are contained in Momen1
      Implicit None
      Type(List),Intent(In)    :: Momen1,Momen2
      Type(List) Delete,C
      Integer ISt,i

      ISt=0
      Do i=1,Momen2%Length
         If(Index(Momen1%Body(:Momen1%Length),
     $   Momen2%Body(i:i)).eq.0) then
            ISt=ISt+1
            C%Body(ISt:ISt)=Momen2%Body(i:i)
         End If
      End Do
      C%Length=ISt
      Delete = C
      End Function Delete
C############################################################
      Function List_Equal(A,B)
C     Returns .true. is lists A and B are equal
      Implicit None
         Type(List),Intent(In)    :: A,B
      Logical List_Equal

      List_Equal = .false.
      If(A%Length.ne.B%Length) Return
      If(A%Body(:A%Length).ne.B%Body(:B%Length)) Return
      List_Equal = .true.
      End Function List_Equal
C############################################################
      End Module ModLet
