      Module ModMom
      Use Md1Mom
      Use ModLet
      Implicit None
      Integer MomDim
      Parameter (MomDim=15)

      Type MomExp
         Integer                              ::  Length
         Type(Momentum), Dimension(MomDim)    ::  Momenta
      End Type MomExp

      Interface Operator (+)
         Module Procedure Add_Momenta
      End Interface
      Interface Operator (-)
         Module Procedure Subtract_Momenta, Change_Sign_Mom
      End Interface
      Interface Operator (.grth.)
         Module Procedure Greater_Than_MomExp
      End Interface      
      Interface Operator (.equal.)
         Module Procedure Equal_MomExp
      End Interface

      Contains
C############################################################
      Function Add_Momenta(A,B)
      Implicit None
      Type(MomExp),Intent(In)   :: A,B
      Type(MomExp)              :: Add_Momenta
      Integer i,ii
            
      Add_Momenta%Length=A%Length + B%Length
      If(Add_Momenta%Length.gt.MomDim)   
     $Write(6,*) 'Warning!! Too long momentum'
      Do i=1,A%Length
         Add_Momenta%Momenta(i)=A%Momenta(i)
      End Do
      Do i=1,B%Length
         ii=i+A%Length
         Add_Momenta%Momenta(ii)=B%Momenta(i)
      End Do
      Call Cancel(Add_Momenta)
      End Function Add_Momenta
C############################################################
      Function Subtract_Momenta(A,B)
      Implicit None
      Type(MomExp),Intent(In)   :: A,B
      Type(MomExp)   :: Subtract_Momenta,C

      C = -B
      Subtract_Momenta = A+C

      End Function Subtract_Momenta
C############################################################
      Function Change_Sign_Mom(A)
      Implicit None
      Type(MomExp),Intent(In)   :: A
      Type(MomExp)              :: Change_Sign_Mom
      Integer        :: i

      Change_Sign_Mom= A
      Do i=1,A%Length
         Change_Sign_Mom%Momenta(i)%Sign = -A%Momenta(i)%Sign 
      End Do

      End Function Change_Sign_Mom
C############################################################
      Function Equal_MomExp(A,B)
      Type(MomExp),Intent(In)        :: A,B
      Logical               :: Equal_MomExp

      Equal_MomExp = .false.
      If((.not.(A.grth.B)).and.(.not.(B.grth.A))) Equal_MomExp=.true.
      End Function Equal_MomExp
C############################################################
      Function Greater_Than_MomExp(A,B)
      Implicit None
      Type(MomExp),Intent(In)     :: A,B
      Logical Greater_Than_MomExp
C     Internal arrays
      Type(MomExp)     :: A2,B2
      Integer i

      Greater_Than_MomExp= .false.
      A2 = A
      B2 = B
      Call OrderMomExp(A2)
      Call OrderMomExp(B2)
      If(A2%Length.gt.B2%Length) then
         Greater_Than_MomExp=.true.
         Return
      Else If(A2%Length.eq.B2%Length) then
         Do i=1,A2%Length
            If(A2%Momenta(i) .grth. B2%Momenta(i)) then
               Greater_Than_MomExp=.true.
               Return                  
            Else If(B2%Momenta(i) .grth. A2%Momenta(i)) then
               Return
            End If
         End Do
      End If
      End Function Greater_Than_MomExp
C############################################################
      End Module ModMom
