      Module ModUVE
      Use Md1UVE
      Implicit None
      Integer nmaxUV

      Parameter(nmaxUV = 20)

      Type UVFunction
         Integer                                  ::  NumUVE
         Type(One_UVFunction), Dimension(nmaxUV)  ::  UVEG
      End Type UVFunction

      Interface Operator (*)
         Module Procedure UVE_Product
      End Interface
      Interface Operator (.grth.)
         Module Procedure Greater_Than_UVE
      End Interface
      Interface Operator (.equal.)
         Module Procedure Equal_UVE
      End Interface

      Contains
C############################################################
      Function Greater_Than_UVE(A,B)
      Implicit None
      Type(UVFunction),Intent(In)        :: A,B
      Logical                 :: Greater_Than_UVE
      Integer i

      Greater_Than_UVE = .false.
      If(A%NumUVE.gt.B%NumUVE) then
         Greater_Than_UVE = .true.
         Return
      Else If(A%NumUVE.lt.B%NumUVE) then
         Return
      Else If(A%NumUVE.eq.B%NumUVE) then
         Do i=1,A%NumUVE
            If(A%UVEG(i) .grth. B%UVEG(i)) then
               Greater_Than_UVE = .true.
               Return
            Else If(B%UVEG(i) .grth. A%UVEG(i)) then
               Return
            End If
         End Do
      End If
      End Function Greater_Than_UVE
C############################################################
      Function Equal_UVE(A,B)
         Implicit None
         Type(UVFunction),Intent(In)        :: A,B
         Logical                 :: Equal_UVE

         Equal_UVE = .false.
         If((.not.(A.grth.B)).and.(.not.(B.grth.A))) 
     $   Equal_UVE = .true.
      End Function Equal_UVE
C############################################################
      Function UVE_Product(A,B)
         Implicit None
         Type(UVFunction),Intent(In)           :: A,B
         Type(UVFunction)            ::UVE_Product
         Integer i,ii

         UVE_Product%NumUVE = A%NumUVE + B%NumUVE
         Do i=1,A%NumUVE
            UVE_Product%UVEG(i) = A%UVEG(i)
         End Do
         Do i=1,B%NumUVE
            ii = A%NumUVE + i
            UVE_Product%UVEG(ii) = B%UVEG(i)
         End Do
      End Function UVE_Product
C############################################################
      End Module ModUVE
