      Subroutine Standr(ExpR)
      Use ModXpr
      Use Md1Mom
      Use ModMom
      Use ModOpr
      Implicit None
      Type(Expression)       :: ExpR
      Type(MomExp) Is,Want,To,FindNewMom
      Type(Momentum) From,ExtractLabeledMom
      Type(List)  UsedMoms
      Type(Energy) Mass
      Integer i,j,IStart,IEnd
      Logical PhysBr
      Integer IType
      COMMON /Type/ IType
      Integer IPrint
      COMMON /Print/ IPrint

C     This subroutine changes variables  so that first
C     LInd  momexps in OperR become p,d,k
C     LInd  is # of independent momenta in OperR.
C     Also arrange spinor indices in proper order.

      If(IPrint.ge.7) 
     $Call Output(6,ExpR,'Before Standr',-1)
      Call SubstituteLabelsExpR(ExpR,'*','$')
      If(IPrint.ge.10) 
     $Call Output(6,ExpR,'After SubstituteLabelsExpR',-1)

      UsedMoms%Length = 0
C     Enforce standard order of variables in Oper
      Do i=1,ExpR%Oper%NumOp

         Is=ExpR%Oper%OperG(i)%Argument
         From=ExtractLabeledMom(Is,'$')
         If(From%Labl.eq.'#') Cycle
         Want = FindNewMom(UsedMoms)
C        Want is momentum that should be there

         Call MakeFromTo(Is,Want,From,To)

         If(IPrint.ge.7) then
            Call Output(6,ExpR,'Before ChangeVariablesExpR',-1)
             Write(6,*)'Standr: To'
            Call Write_Momentum(6,To)
         End If
         Call ChangeVariablesExpR(ExpR,From,To)            
         If(IPrint.ge.7) 
     $   Call Output(6,ExpR,'After  ChangeVariablesExpR',-1)

      End Do

      Call OrdLng(ExpR)

      If(IPrint.ge.10)
     $Call Output(6,ExpR,'after changing OperR',-1)

      Do i=1,ExpR%UVE%NumUVE
         Is=ExpR%UVE%UVEG(i)%Argument
         From=ExtractLabeledMom(Is,'$')

         If(From%Labl.eq.'#') Cycle

         Want = FindNewMom(UsedMoms)
C        Want is momentum that should be there
         Call MakeFromTo(Is,Want,From,To)

         Call ChangeVariablesExpR(ExpR,From,To)            
      End Do

      If(IPrint.ge.10) 
     $Call Output(6,ExpR,'after changing UVER',-1)

      Call OrdUVE(ExpR%UVE) 

      If(IPrint.ge.10)
     $Call Output(6,ExpR,'after OrdUVE',-1)

C     Arrange spinor indices
      Call ArngId(ExpR%Oper,ExpR%UVE,ExpR%Gam)
      Call OrderGamma(ExpR%Gam)

      If(IPrint.ge.10) 
     $Call Output(6,ExpR,'after changing indices',-1)

C      If(IType.eq.6.and.(.not.PhysBr(ExpR%Denominator,ExpR%Delta))) then
      If(IType.eq.6) then

C        Apply the MSC to the denominator
         Mass=ExpR%Exponent%Expi(1)
         Do i=1,ExpR%Denominator%NumDen
            Call BraExp(ExpR%Denominator%Denom(i),Mass,0)
         End Do
         Call Order_Bracket(ExpR%Denominator,ExpR%IPowr)
         If(IPrint.ge.9) Call Output(6,ExpR,'AplMas:After BraNum',-1)
         Call BraExp(ExpR%Exponent%Expi(2),Mass,1)
      End If

      Call PreDen(ExpR%Denominator,ExpR%IPowr)
      
C     Put also Expi in the standard form
      Call OrderEnergy(ExpR%Exponent%Expi(1))
      Call OrderEnergy(ExpR%Exponent%Expi(2))

      If(IPrint.ge.7) Call Output(6,ExpR,'Term xxx after Standr',-1)

      Return
      End
