C############################################################
      Function Fermion_Operator(A)
         Use Md1Opr
         Implicit None
         Logical Fermion_Operator,Electron_Operator
         Logical Positron_Operator
         Type(One_Operator)         :: A

         Fermion_Operator = .false.
         If(Electron_Operator(A).or.Positron_Operator(A))
     $   Fermion_Operator=.true.
      Return
      End 
C############################################################
      Function Electron_Operator(A)
         Use Md1Opr
         Implicit None
         Logical Electron_Operator
         Type(One_Operator)         :: A

         Electron_Operator = .false.
         If( A%Title(1:1).eq.'A'.or.A%Title(1:1).eq.'a')
     $   Electron_Operator=.true.
      Return
      End 
C############################################################
      Function Positron_Operator(A)
         Use Md1Opr
         Implicit None
         Logical Positron_Operator
         Type(One_Operator)         :: A

         Positron_Operator = .false.
         If( A%Title(1:1).eq.'B'.or.A%Title(1:1).eq.'b')
     $   Positron_Operator=.true.
      Return
      End 
C############################################################
      Function Photon_Operator(A)
         Use Md1Opr
         Implicit None
         Logical Photon_Operator
         Type(One_Operator)         :: A

         Photon_Operator = .false.
         If( A%Title(1:1).eq.'C'.or.A%Title(1:1).eq.'c')
     $   Photon_Operator=.true.
      Return
      End 
C############################################################
      Function Electron_Creation(A)
         Use Md1Opr
         Implicit None
         Logical Electron_Creation
         Type(One_Operator)         :: A

         Electron_Creation = .false.
         If( A%Title.eq.'A^'
     $   .or.A%Title.eq.'a^') Electron_Creation=.true.
      Return
      End 
C############################################################
      Function Electron_Destruction(A)
         Use Md1Opr
         Implicit None
         Logical Electron_Destruction
         Type(One_Operator)         :: A

         Electron_Destruction = .false.
         If( A%Title.eq.'A_'
     $   .or.A%Title.eq.'a_') Electron_Destruction=.true.
      Return
      End 
C############################################################
      Function Positron_Creation(A)
         Use Md1Opr
         Implicit None
         Logical Positron_Creation
         Type(One_Operator)         :: A

         Positron_Creation = .false.
         If( A%Title.eq.'B^'
     $   .or.A%Title.eq.'b^') Positron_Creation=.true.
      Return
      End 
C############################################################
      Function Positron_Destruction(A)
         Use Md1Opr
         Implicit None
         Logical Positron_Destruction
         Type(One_Operator)         :: A

         Positron_Destruction = .false.
         If( A%Title.eq.'B_'
     $   .or.A%Title.eq.'b_') Positron_Destruction=.true.
      Return
      End 
C############################################################
      Function Photon_Creation(A)
         Use Md1Opr
         Implicit None
         Logical Photon_Creation
         Type(One_Operator)         :: A

         Photon_Creation = .false.
         If( A%Title.eq.'C^'
     $   .or.A%Title.eq.'c^') Photon_Creation=.true.
      Return
      End 
C############################################################
      Function Photon_Destruction(A)
         Use Md1Opr
         Implicit None
         Logical Photon_Destruction
         Type(One_Operator)         :: A

         Photon_Destruction = .false.
         If( A%Title.eq.'C_'
     $   .or.A%Title.eq.'c_')Photon_Destruction=.true.
      Return
      End 
C############################################################
      Function Creation_Operator(a)
         Use Md1Opr
         Implicit None
         Logical Creation_Operator
         Type(One_Operator)         :: A

         Creation_Operator=.false.
         If(A%Title(2:2).eq.'^') Creation_Operator=.true.
      Return
      End 
C############################################################
      Function Destruction_Operator(A)
         Use Md1Opr
         Implicit None
         Logical Destruction_Operator
         Type(One_Operator)         :: A

         Destruction_Operator=.false.
         If(A%Title(2:2).eq.'_') Destruction_Operator=.true.
      Return
      End 
C############################################################
      Function Small_Operator(A)
         Use Md1Opr
         Implicit None
         Logical Small_Operator
         Type(One_Operator)         :: A

         Small_Operator=.false.
         If( A%Title(1:1).eq.'a'
     $   .or.A%Title(1:1).eq.'b'
     $   .or.A%Title(1:1).eq.'c')Small_Operator=.true.
      Return
      End 
C############################################################
      Function Big_Operator(A)
         Use Md1Opr
         Implicit None
         Logical Big_Operator
         Type(One_Operator)         :: A

         Big_Operator=.false.
         If( A%Title(1:1).eq.'A'
     $   .or.A%Title(1:1).eq.'B'
     $   .or.A%Title(1:1).eq.'C')Big_Operator=.true.
      Return
      End 
C############################################################
      Function NonZeroCommutator(A,B)
         Use Md1Opr
         Implicit None
         Type(One_Operator)         :: A,B
         Logical NonZeroCommutator,Electron_Destruction
         Logical Electron_Creation
         Logical Positron_Destruction,Positron_Creation
         Logical Photon_Destruction, Photon_Creation

         NonZeroCommutator=.false.
         If( Electron_Destruction(A).and.Electron_Creation(B)
     $   .or.Electron_Creation   (A).and.Electron_Destruction(B)
     $   .or.Positron_Destruction(A).and.Positron_Creation(B)
     $   .or.Positron_Creation   (A).and.Positron_Destruction(B)
     $   .or.Photon_Destruction(A)  .and.Photon_Creation   (B)
     $   .or.Photon_Creation   (A)  .and.Photon_Destruction(B))
     $   NonZeroCommutator=.true.
      Return
      End     
C############################################################
      Subroutine Swap_Oper(Oper1,Oper2)
C        Change order of two operators in OperR
         Use Md1Opr
         Implicit None
         Type(One_Operator)  :: Oper1,Oper2,OperX

         OperX = Oper1
         Oper1 = Oper2
         Oper2 = OperX
      Return
      End 
C############################################################
      Function ReadOneOperator(IFileN,Status)
         Use Md1Opr
         Use ModMom
         Implicit None
         Type(One_Operator) ReadOneOperator
         Type(List) Momen1
         Integer IFileN,Status,i,IEnd
         Integer IPrint
         Type(MomExp) ExtractMomExp
         COMMON /Print/ IPrint

         Read(IFileN,*)Momen1%Body
         If(Momen1%Body(1:1).eq.'x') then
C            If(IPrint.ge.0) Write(6,*)'x'
            Status=-1
         Else
            ReadOneOperator%Title = Momen1%Body(1:2)
            IEnd = Index(Momen1%Body,' ') -1
            Momen1%Length = IEnd - 2
            If(IPrint.ge.0) Write(6,*)Momen1%Body(:IEnd)
            Momen1%Body(:Momen1%Length) = Momen1%Body(3:IEnd)
            ReadOneOperator%Argument
     $      = ExtractMomExp(Momen1)
            Read (IFileN,*) ReadOneOperator%Index(1),
     $                      ReadOneOperator%Index(2)
            If(IPrint.ge.0) Write(6,*)ReadOneOperator%Index(1),
     $                                ReadOneOperator%Index(2)
         End If
      Return
      End 
C############################################################
