C############################################################
      Subroutine RedNOz(A)
         Use ModBrk
         Implicit None
         Type(Bracket)                :: A,B
         Type(Energy) C
         Integer i,k
         Integer FindOzMatch

C        Om(x) = 1/sqrt(x^2 + m^2)
C        Oz(x) = 1/sqrt(|2x|)
C        Os(x) = 1/|2x|

         B%NumDen=0
         Do i=1,A%NumDen
            If( A%Denom(i)%NumO.gt.1) then
               Call PutAtoB(A%Denom(i),B)
            Else If(A%Denom(i)%NumO.eq.1              
     $      .and.(A%Denom(i)%Energies(1)%Title.eq.'Om'
     $      .or.  A%Denom(i)%Energies(1)%Title.eq.'Os')) then
               Call PutAtoB(A%Denom(i),B)
            Else If(A%Denom(i)%NumO.eq.1              
     $      .and.(A%Denom(i)%Energies(1)%Title.eq.'Oz')) then
               k=FindOzMatch(A,i)
               If(k.gt.0) then
                  A%Denom(i)%Energies(1)%Title = 'xx'
                  A%Denom(k)%Energies(1)%Title = 'xx'
                  C%Sign =  A%Denom(i)%Sign * A%Denom(k)%Sign
     $            *A%Denom(i)%Energies(1)%Sign
     $            *A%Denom(k)%Energies(1)%Sign
                  C%NumO = 1
                  C%Energies(1)%Sign = 1
                  C%Energies(1)%Title = 'Os'
                  C%Energies(1)%Momentum 
     $            =A%Denom(i)%Energies(1)%Momentum
                  Call PutAtoB(C,B)
               Else If(k.eq.0) then
                  Call PutAtoB(A%Denom(i),B)
               End If
            End If
         End Do
         A = B
         Return
      End
C############################################################
      Subroutine PutAtoB(A,B)
         Use ModBrk
         Implicit None
         Type(Bracket)                :: B
         Type(Energy) A

              B%NumDen=B%NumDen+1
              B%Denom(B%NumDen) = A
              A%Energies(1)%Title = 'xx'
      Return
      End
C############################################################
      Function FindOzMatch(A,i)
C     Returns index of Oz term that matches term # i
         Use ModBrk
         Implicit None
      Type (Bracket)                :: A
      Type (Energy) ADen,ADenm
      Integer                       :: FindOzMatch,i,k

         FindOzMatch = 0
         ADen = A%Denom(i)
         ADenm = -ADen
         Do k = i+1,A%NumDen
            If(A%Denom(k)%Energies(1)%Title.eq.'xx') Cycle
            If(A%Denom(k)%NumO.ne.1) Cycle
            If ((A%Denom(k).equal.ADen)
     $      .or.(A%Denom(k).equal.-ADenm)) then
               FindOzMatch = k
               Return
            End If        
         End Do
         Return
      End 
C############################################################
      Function Find_Largest_Brk(B,k)
         Use ModBrk
         Implicit None
         Type(Bracket)   :: B
         Integer         :: k,i,IStart
         Type(Energy)    :: Current,Find_Largest_Brk
            
         Do i=1,B%NumDen
            If(B%Denom(i)%Energies(1)%Title.eq.'##') Cycle
            Current = B%Denom(i)
            k = i
            IStart=k+1
            Exit
         End Do
         Do i=IStart,B%NumDen
            If(B%Denom(i)%Energies(1)%Title.eq.'##') Cycle
            If(B%Denom(i) .grth. Current) then
               Current=B%Denom(i)
               k=i
            End If
         End Do
         Find_Largest_Brk=Current
         Return
      End 
C############################################################
      Function ListVariablesBrk(A,Labl)
         Use ModBrk
         Implicit None
         Type(Bracket)             :: A
         Type(List)                   :: ListVariablesBrk
         Type(List) ListVariablesEn
         Character Labl
         Integer i

         ListVariablesBrk%Length=0
         If(A%NumDen.ge.1) 
     $   ListVariablesBrk = ListVariablesEn(A%Denom(1),Labl)
         Do i=2,A%NumDen
            ListVariablesBrk = ListVariablesBrk
     %      * ListVariablesEn(A%Denom(i),Labl)
         End Do
         Call ShrinkList(ListVariablesBrk)
         Return
      End 
C############################################################
      Subroutine Read_Brk(IFilen,A)
         Use ModBrk
         Use ModEnr
         Implicit None
         Type(Bracket)             :: A
         Type(List) Momen1
         Type(Energy) Extract_Energy
         Integer i,LMom1,IFilen
         Integer IPrint
         COMMON /Print/ IPrint

         A%NumDen = 0
         Do i=1,NumOmx
            Read(IFileN,*)Momen1%Body

            If(Momen1%Body(1:1).eq.'x') then
               If(IPrint.ge.0) Write(6,*) 'x'
               Exit
            Else
               LMom1=Index(Momen1%Body,' ')-1
               Momen1%Length = LMom1
               If(IPrint.ge.0) Write(6,*) Momen1%Body(:LMom1) 
               A%Denom(i) = Extract_Energy(Momen1)
               A%NumDen=A%NumDen + 1
            End If
         End Do
         Return
      End 
C############################################################
      Subroutine Write_Brk(NumFil,A)
      Use ModBrk
      Use ModEnr
      Implicit None
      Type(Bracket)             :: A
      Integer i,NumFil

      Do i=1,A%NumDen
         Call Write_Energy(NumFil,A%Denom(i))
      End Do
      Write(NumFil,*) 'x'
      Return
      End 
C############################################################
      Function PhysBr(A)
      Use ModBrk
      Use ModEnr
      Implicit None
      Type(Bracket) A
      Type(MomExp) Delta
      Logical PhysBr,Physic
      Integer i

      PhysBr = .false.
      Do i=1,A%NumDen
         If(Physic(A%Denom(i))) then
            PhysBr = .true.
            Return
         End If
      End Do

      Return
      End
C############################################################
