C############################################################
      Function Find_Smallest_Op(B,k)
         Use ModOpr
         Use ModMom
         Implicit None
         Type(Operator)   :: B
         Integer        :: k,i,IStart
         Type(One_Operator) :: Current,Find_Smallest_Op

         Do i=1,B%NumOp
            If(B%OperG(i)%Title.eq.'##') Cycle
            Current = B%OperG(i)
            k=i
            IStart=k+1
            Exit
         End Do
         Do i=IStart,B%NumOp
            If(B%OperG(i)%Title.eq.'##') Cycle
            If(Current%Argument .grth. B%OperG(i)%Argument) then
               Current=B%OperG(i)
               k=i
            End If
         End Do
         Find_Smallest_Op=Current
      Return
      End 
C############################################################
      Subroutine ChangeIndices(Oper,From,To)
         Use ModOpr
         Implicit None
         Type(Operator)              :: Oper
         Integer                     :: From,To,j

         Do j=1,Oper%NumOp
           If(Oper%OperG(j)%Index(1).eq.From) 
     $     Oper%OperG(j)%Index(1)=To
           If(Oper%OperG(j)%Index(2).eq.From) 
     $     Oper%OperG(j)%Index(2)=To 
         End Do
      Return
      End 
C############################################################
      Function ListVariablesOp(A,Labl)
         Use ModOpr
         Use ModMom
         Implicit None
         Type(Operator)               :: A
         Type(List) :: ListVariablesOp, ListVariables
         Integer i
         Character Labl

         If(A%NumOp.eq.0) then
            ListVariablesOp%Length=0
            Return
         End If
         ListVariablesOp 
     $   = ListVariables(A%OperG(1)%Argument,Labl)
         Do i=2,A%NumOp
            ListVariablesOp = ListVariablesOp 
     %      * ListVariables(A%OperG(i)%Argument,Labl)
         End Do
         Call ShrinkList(ListVariablesOp)
      Return
      End 
C############################################################
      Subroutine TypeDg(Oper,KType,NConn)
C     Determine connectivity of the Feynman diagram
C     and find out what is the type of the diagram
C     KType
C     0      Physical ...  All parts are physical
C     1      Renorm   ...  At least one part is renorm,no parts are
C                          unphysical
C     2      Unphysical ... At least one part is unphysical
C      These numbers will be put in array IConn
         Use ModOpr
         Implicit None
      Type(Operator)      :: Oper,A
      Integer             :: KType,NConn,m,j,NonZer,k
      Integer             :: NCr,NDe
      Logical Belongs,Letter

      Integer, Dimension(nmaxOp)      :: IConn

C     Internal arrays
      Type(List) Momen1,Momen3,ListVariables
      Integer IPrint
      COMMON /Print/ IPrint

      A = Oper
      NConn=0
      Do m=1,nmaxOp
         IConn(m)=1
      End Do
      Do m=1,nmaxOp
C        Start new subdiagram
C        Momen1 accumulates momentum labels of the subdiagram
C        Terms that have ben joined to the subdiagram are marked by 
C        setting A%OperG(j)%Argument%Length to 0
         NCr=0
         NDe=0
         Do j=1,A%NumOp
            If(A%OperG(j)%Argument%Length.eq.0)Cycle

            Momen1= ListVariables(A%OperG(j)%Argument,'*')
            If(A%OperG(j)%Title(2:2).eq.'^') then
               NCr=NCr+1
            Else If(A%OperG(j)%Title(2:2).eq.'_') then
               NDe=NDe+1
            End If
            A%OperG(j)%Argument%Length = 0
            NConn=NConn+1
            Goto 56
         End Do
C        No more subdiagrams
         Exit
 56      Continue
 55      Continue
         NonZer=0
         Do j=1,A%NumOp
C           Eliminate all terms in the same group as Momen1
            If(A%OperG(j)%Argument%Length.eq.0)Cycle

            Momen3=ListVariables(A%OperG(j)%Argument,'*')
            If(Letter(Momen1,Momen3)) then
               Momen1 = Momen1 * Momen3
               Call ShrinkList(Momen1)
               If(A%OperG(j)%Title(2:2).eq.'^') then
                  NCr=NCr+1
               Else If(A%OperG(j)%Title(2:2).eq.'_') then
                  NDe=NDe+1
               End If
               A%OperG(j)%Argument%Length = 0
               NonZer=1
            End If
         End Do
         If(NonZer.eq.1) Goto 55
C           There is a chance to find more terms from this group
C        Find out the type of the subdiagram
         If(NConn.eq.0) Exit
C        There are no subdiagrams

         If(NCr.ge.2.and.NDe.ge.2) then
C           This is a physical term
            IConn(NConn)=0
         Else If(NCr.eq.NDe.and.NCr+NDe.le.2) then
C           This is a renormalization term
            IConn(NConn)=1
         Else 
C           This is a non-physical term
            IConn(NConn)=2
         End If
      End Do
 57   Continue
      If(IPrint.ge.10) Write(6,*)(IConn(m),m=1,NConn)

C     If at least one subdiagram is not physical, then
C     The term is either renorm or unphysical
C     Otherwise it is physical

C     If at least one diagram is unphysical then the term is unphysical

      If(Belongs(2,IConn,NConn)) then
         KType=2
      Else If(.not.Belongs(2,IConn,NConn).and.Belongs(1,IConn,NConn))
     $ then
         KType=1
      Else
         KType=0
      End If
         
      If(IPrint.ge.10) Write(6,*) 'NConn= ',NConn
      Return
      Return
      End 
C############################################################
      Function Form_Oper(A)
         Use ModOpr
         Implicit None
         Type(One_Operator) A
         Type(Operator) Form_Oper

         Form_Oper%NumOp = 1 
         Form_Oper%OperG(1) = A 
      Return    
      End 
C############################################################
      Subroutine Read_Operator(IFilen,A,IStop)
         Use ModOpr
         Implicit None
         Type(Operator) A
         Type(One_Operator) ReadOneOperator
         Integer k,IStop,Status,IFilen
         Integer IPrint
         COMMON /Print/ IPrint

         A%NumOp = 0
         Status = 0
         Do k=IStOp,nmaxOp
            A%OperG(k) = ReadOneOperator(IFileN,Status)
            If(Status.eq.-1) Exit
            A%NumOp = A%NumOp + 1
         End Do
         If(IPrint.ge.0) Write(6,*)'x'   
      Return
      End 
C############################################################
      Subroutine Write_Operator(NumFil,A)
         Use ModOpr
         Use ModMom
         Implicit None
         
         Type(Operator) A
         Type(List) Momen,Momen5,MomExpToString
         Integer i,NumFil

      Do i=1,A%NumOp
         Momen=MomExpToString(A%OperG(i)%Argument)
         Momen5%Length = Momen%Length + 2
         Momen5%Body(:Momen5%Length) =
     $   A%OperG(i)%Title//Momen%Body(:Momen%Length)

         Write(NumFil,*)  Momen5%Body(:Momen5%Length)
         Write(NumFil,*) A%OperG(i)%Index(1),
     $   A%OperG(i)%Index(2)
      End Do
      Return
      End 
C############################################################
      Function ExtractLabels(Oper)
         Use ModOpr
         Implicit None
         Type(Operator) Oper
         Type(List) ExtractLabels
         Integer ii,j

         ii=-1
         Do j=1,Oper%NumOp
            ii=ii+2
             ExtractLabels%Body(ii:ii+1) =Oper%OperG(j)%Title
         End Do
         ExtractLabels%Length=ii+1
      Return
      End 
C############################################################

