C############################################################
      Function GrTh2(AA,BB)
C     Do not take into account exponents
      Use ModXpr
      Implicit None
      Type(Expression),Intent(In)      :: AA,BB
      Type(Expression)      :: A,B
      Logical               :: GrTh2
      Integer IPrint
      COMMON /Print/ IPrint

      GrTh2 = .false.
      A = AA
      B = BB
      If(A%Oper .grth. B%Oper) then
         GrTh2 = .true.
         Return
      End If
      If(B%Oper .grth . A%Oper) Return

C     We come here if A%Oper = B%Oper
      If(A%UVE .grth. B%UVE) then
         GrTh2 = .true.
         Return
      End If
      If(B%UVE .grth . A%UVE) Return

C     We come here if A%UVE = B%UVE
      If(A%Gam .grth. B%Gam) then
         GrTh2 = .true.
         Return
      End If
      If(B%Gam .grth . A%Gam) Return

C     We come here if A%Gam = B%Gam
      If(A%Denominator .grth. B%Denominator) then
         GrTh2 = .true.
         Return
      End If
      If(B%Denominator .grth. A%Denominator) Return

C     We come here if A%Denominator = B%Denominator
C      If(A%Delta .grth. B%Delta) GrTh2 = .true.

      Return
      End 
C############################################################
      Function GrTh3(AA,BB)
C     For denominators take into account only number of terms
      Use ModXpr
      Implicit None
      Type(Expression),Intent(In)      :: AA,BB
      Type(Expression) A,B
      Logical               :: GrTh3
      Integer IPrint
      COMMON /Print/ IPrint

      GrTh3 = .false.
      A = AA
      B = BB

      If(A%Oper .grth. B%Oper) then
         GrTh3 = .true.
         Return
      End If
      If(B%Oper .grth . A%Oper) Return

C     We come here if A%Oper = B%Oper
      If(A%UVE .grth. B%UVE) then
         GrTh3 = .true.
         Return
      End If
      If(B%UVE .grth . A%UVE) Return

C     We come here if A%UVE = B%UVE
      If(A%Gam .grth. B%Gam) then
         GrTh3 = .true.
         Return
      End If
      If(B%Gam .grth . A%Gam) Return

C     We come here if A%Gam = B%Gam

C      If(A%Delta .grth. B%Delta) then
C         GrTh3 = .true.
C         Return
C      End If
C      If(B%Delta .grth. A%Delta) Return

      If(A%Exponent .grth. B%Exponent) then
         GrTh3 = .true.
         Return
      End If
      If(B%Exponent .grth . A%Exponent) Return

C     We come here if A%Exponent = B%Exponent
      If(A%Denominator%NumDen.gt.
     $B%Denominator%NumDen) GrTh3 = .true.
      Return
      End 
C############################################################
      Subroutine Cancel_ExpR(ExpR)
      Use ModXpr
      Use ModEnr
      Implicit None
      Type(Expression) ExpR
      Integer i,j

      Do i=1,ExpR%Oper%NumOp
         Call Cancel(ExpR%Oper%OperG(i)%Argument)
      End Do
      Do i=1,ExpR%UVE%NumUVE
         Call Cancel(ExpR%UVE%UVEG(i)%Argument)
      End Do
      Do i=1,ExpR%Denominator%NumDen
         Do j=1,ExpR%Denominator%Denom(i)%NumO
            Call Cancel(ExpR%Denominator%Denom(i)%Energies(j)%Momentum)
         End Do
      End Do
      Do i=1,ExpR%Exponent%Expi(1)%NumO
         Call Cancel(ExpR%Exponent%Expi(1)%Energies(i)%Momentum)
      End Do
      Do i=1,ExpR%Exponent%Expi(2)%NumO
         Call Cancel(ExpR%Exponent%Expi(2)%Energies(i)%Momentum)
      End Do
C      Call Cancel(ExpR%Delta)
      Return
      End 
C############################################################
      Subroutine SubstituteLabelsExpR(A,From,To)
      Use ModXpr
      Implicit None
      Type(Expression)            :: A
      Character                   :: From, To
      Integer i,j

      Do i=1,A%Oper%NumOp
         Call SubstituteLabels(A%Oper%OperG(i)%Argument,From,To)
      End Do
      Do i=1,A%UVE%NumUVE
         Call SubstituteLabels(A%UVE%UVEG(i)%Argument,From,To)
      End Do

      Do i=1,A%Denominator%NumDen
         Do j=1,A%Denominator%Denom(i)%NumO
            Call SubstituteLabels(A%Denominator%Denom(i)%
     $      Energies(j)%Momentum,From,To)
         End Do
      End Do
      Do i=1,2
         Do j=1,A%Exponent%Expi(i)%NumO
            Call SubstituteLabels
     $      (A%Exponent%Expi(i)%Energies(j)%Momentum,From,To)
         End Do
      End Do
C      Call SubstituteLabels(A%Delta,From,To)
      Return
      End 
C############################################################
      Subroutine ChangeVariablesExpR(A,From,To)
      Use ModXpr
      Use Md1Mom
      Implicit None
      Type(Expression)            :: A
      Type(MomExp)                :: To
      Type(Momentum)              :: From
      Integer i,j
      Integer IPrint
      COMMON /Print/ IPrint

      Do i=1,A%Oper%NumOp
         Call ChangeVariables
     $   (A%Oper%OperG(i)%Argument,From,To)
      End Do

      Do i=1,A%UVE%NumUVE
         Call ChangeVariables
     $   (A%UVE%UVEG(i)%Argument,From,To)
      End Do
        
      Do i=1,A%Denominator%NumDen
         Do j=1,A%Denominator%Denom(i)%NumO
            Call ChangeVariables
     $      (A%Denominator%Denom(i)%Energies(j)%Momentum,
     $      From,To)
         End Do
         Call OrderEnergy(A%Denominator%Denom(i))
      End Do
      Call Order_Bracket(A%Denominator,A%IPowr)

      Do i=1,2
         Do j=1,A%Exponent%Expi(i)%NumO
            Call ChangeVariables
     $      (A%Exponent%Expi(i)%Energies(j)%Momentum,From,To)
         End Do
         Call OrderEnergy(A%Exponent%Expi(i))
      End Do
C      Call ChangeVariables(A%Delta,From,To)
      Return
      End 
C############################################################
      Subroutine Relabl(ILast,UVE,Gam,Oper)
      Use ModXpr
      Implicit None
      Type(UVFunction)                :: UVE
      Type(Gamma)                     :: Gam
      Type(Operator)                  :: Oper
C     Internal arrays
      Integer Total_Dim,ILast,IndCur,IndOld,i,j
      Integer,Dimension(2*(nmaxUV+nmaxOp+nmaxGm)) :: Index
      Integer,Dimension(2*(nmaxUV+nmaxOp+nmaxGm)) :: Index2

C     Flatten up index arrays
      Total_Dim = 2*(Oper%NumOp+UVE%NumUVE+Gam%NumGam)     
      Call IClear(Index2,Total_Dim)
      Call Flaten(UVE,Gam,Oper,Index)
C     Relabel indices
      IndCur=ILast      
      Do i=1,Total_Dim
         If(Index(i).ne.0.and.Index2(i).eq.0) then
            IndCur=IndCur+1
            IndOld=Index(i)
            Index2(i)=IndCur
            Do j=i+1,Total_Dim
               If(Index(j).eq.IndOld
     $         .and.Index2(j).eq.0) Index2(j)=IndCur
            End Do
         End If
      End Do
      Call UnFlat(UVE,Gam,Oper,Index2)
      ILast=IndCur
      Return
      End 
C############################################################
      Subroutine UnFlat(UVE,Gam,Oper,Index)
      Use ModXpr
      Implicit None
      Type(UVFunction)                :: UVE
      Type(Gamma)                     :: Gam
      Type(Operator)                  :: Oper
      Integer,Dimension(2*(nmaxUV+nmaxOp+nmaxGm)) :: Index
      Integer i,Ic

      Ic=0
      Do i=1,Oper%NumOp
         Ic=Ic+1
         Oper%OperG(i)%Index(1)=Index(Ic)
         Ic=Ic+1
         Oper%OperG(i)%Index(2)=Index(Ic)
      End Do
      Do i=1,UVE%NumUVE
         Ic=Ic+1
         UVE%UVEG(i)%Index(1)=Index(Ic)
         Ic=Ic+1
         UVE%UVEG(i)%Index(2)=Index(Ic)
      End Do
      Do i=1,Gam%NumGam
         Ic=Ic+1
         Gam%GamG(i)%Index(1)=Index(Ic)
         Ic=Ic+1
         Gam%GamG(i)%Index(2)=Index(Ic)
      End Do
      Return
      End 
C############################################################
      Subroutine Flaten(UVE,Gam,Oper,Index)
      Use ModXpr
      Implicit None
      Type(UVFunction)                :: UVE
      Type(Gamma)                     :: Gam
      Type(Operator)                  :: Oper
      Integer,Dimension(2*(nmaxUV+nmaxOp+nmaxGm)) :: Index
      Integer i,Ic

      Ic=0
      Do i=1,Oper%NumOp
         Ic=Ic+1
         Index(Ic)=Oper%OperG(i)%Index(1)
         Ic=Ic+1
         Index(Ic)=Oper%OperG(i)%Index(2)
      End Do
      Do i=1,UVE%NumUVE
         Ic=Ic+1
         Index(Ic)=UVE%UVEG(i)%Index(1)
         Ic=Ic+1
         Index(Ic)=UVE%UVEG(i)%Index(2)
      End Do
      Do i=1,Gam%NumGam
         Ic=Ic+1
         Index(Ic)=Gam%GamG(i)%Index(1)
         Ic=Ic+1
         Index(Ic)=Gam%GamG(i)%Index(2)
      End Do
      Return
      End 
C############################################################
      Subroutine FormUV(ExpR,Letter,jj,kk,Momen1)
      Use ModXpr
      Implicit None
      Type(Expression)                 :: ExpR
      Integer jj,kk,Ind
      Character Letter
      Type(MomExp)                   :: Momen1      
      Logical Destruction_Operator, Creation_Operator

      Ind = ExpR%UVE%NumUVE+1
      ExpR%UVE%NumUVE=Ind
      ExpR%UVE%UVEG(Ind)%Title = Letter
      ExpR%UVE%UVEG(Ind)%Argument = Momen1

C     First index in U correspond to annihilation operator
      If(Destruction_Operator(ExpR%Oper%OperG(jj))) then
          ExpR%UVE%UVEG(Ind)%Index(1)=ExpR%Oper%OperG(jj)%Index(1)
          ExpR%UVE%UVEG(Ind)%Index(2)=ExpR%Oper%OperG(kk)%Index(1)
      Else If(Creation_Operator(ExpR%Oper%OperG(jj))) then
          ExpR%UVE%UVEG(Ind)%Index(1)=ExpR%Oper%OperG(kk)%Index(1)
          ExpR%UVE%UVEG(Ind)%Index(2)=ExpR%Oper%OperG(jj)%Index(1)
      End If
      Return
      End 
C############################################################
      Subroutine FormE(ExpR,Letter,jj)
      Use ModXpr
      Implicit None
      Type(Expression)   :: ExpR
      Integer jj,Ind
      Character Letter

      Ind = ExpR%Gam%NumGam+1  
      ExpR%Gam%NumGam = Ind
      ExpR%Gam%GamG(Ind)%Title = Letter
      ExpR%Gam%GamG(Ind)%Label = '*'

C     In the photon case the destruction operator always goes first
      ExpR%Gam%GamG(Ind)%Index(1)=ExpR%Oper%OperG(jj)%Index(1)
      ExpR%Gam%GamG(Ind)%Index(2)=ExpR%Oper%OperG(jj)%Index(2) 
      Return
      End 
C############################################################
      Function ListVariablesExpR(A,Labl)
      Use ModXpr
      Implicit None
      Type(Expression)             :: A
      Type(List)                   :: ListVariablesExpR
      Integer i
      Character Labl
      Type(List) ListVariablesUVE,ListVariablesOp 
      Type(List) ListVariablesBrk

      ListVariablesExpR = ListVariablesUVE(A%UVE,Labl)
      ListVariablesExpR = ListVariablesExpR *
     $ListVariablesOp(A%Oper,Labl)
      ListVariablesExpR = ListVariablesExpR *
     $ListVariablesBrk(A%Denominator,Labl)

      Call ShrinkList(ListVariablesExpR)
      Return
      End 
C############################################################
      Subroutine DivIndExpR(ExpR)
C     Calculates IPwrR(7) - divergence index of the integral
      Use ModXpr 
      Use ModDNT
      Implicit None
      Type(Expression) ExpR
      Type(List) Momen4,Momen1
      Integer i,DivInd
      Type(List) ListVariablesOp,ListVariablesUVE
      Type(LIst) ListVariablesBrk
      Integer IPrint
      COMMON /Print/ IPrint


      ExpR%IPowr(7)=0

C     Put integration variables from UVE,Denominator in Momen4
      Momen1 = ListVariablesOp(ExpR%Oper,'*') * DoNotT
      Call ShrinkList(Momen1)
      Momen4 = ListVariablesUVE(ExpR%UVE,'*') *
     $         ListVariablesBrk(ExpR%Denominator,'*')
      Momen4 = Momen4 - Momen1
      Call ShrinkList(Momen4)

      If(Momen4%Length.gt.1.and.IPrint.ge.0) then
         Write(6,*)
     $   'Warning!!! # of integration variables in term  = '
     $   ,Momen4%Length
      Else If(Momen4%Length.eq.1) then
C        Determine the divergence index, i.e. power of the
C        integration variable in denominator
C        Number stored in IPowrR(7) is double of power in
C        denominator
         Do i=1,ExpR%Denominator%NumDen
            ExpR%IPowr(7) = ExpR%IPowr(7) 
     $      + DivInd(ExpR%Denominator%Denom(i),Momen4%Body(1:1))
         End Do
      End If
      Return
      End 
C############################################################
      Subroutine Read_UVE_Gam(IFileN,UVE,Gam)
      Use ModXpr
      Implicit None
      Type(List)                   :: Momen1,Momen2
      Type(UVFunction)             :: UVE
      Type(Gamma)                  :: Gam
      Integer IFileN,i,LMom1,j
      Integer, Dimension(nmaxUV+nmaxGm) :: Indx
      Integer, Dimension(nmaxUV)   :: ISLOp3
      Integer, Dimension(nmaxGm)   :: ISLOp4
      Integer n,IStGam
      Type(MomExp) ExtractMomExp
      Integer IPrint
      COMMON /Print/ IPrint

      UVE%NumUVE=0
      Gam%NumGam=0

      Read(IFileN,*)Momen1%Body
      If(Momen1%Body(1:1).eq.'x') then
         If(IPrint.ge.0) Write(6,*) 'x'
         Return
      End If

      LMom1=Index(Momen1%Body,' ')-1
      Momen1%Length = LMom1
      Call IClear(ISLOp3,nmaxUV)
      Call IClear(ISLOp4,nmaxUV)

      Call PntLst
     $(UVE%NumUVE,Momen1%Body(:LMom1),ISLOp3,'(',nmaxUV,1,
     $LMom1)
      Call PntLst
     $(n,Momen1%Body(:LMom1),ISLOp4,')',nmaxUV,1,
     $LMom1)

      If(n.gt.0) then
         IStGam=ISLOp4(n)+1
      Else
         IStGam=1
         Goto 10
      End If

      ISLOp3(UVE%NumUVE+1) =IStGam+1
      Do i=1,UVE%NumUVE
         UVE%UVEG(i)%Title=Momen1%Body(ISLOp3(i)-1:ISLOp3(i)-1)
         Momen2%Length = ISLOp3(i+1)-ISLOp3(i)-1
         Momen2%Body = Momen1%Body(ISLOp3(i):ISLOp3(i+1)-2)
         UVE%UVEG(i)%Argument = ExtractMomExp(Momen2)
      End Do

 10   Continue
      Momen1%Body(:LMom1-IStGam+1)=Momen1%Body(IStGam:LMom1)
      LMom1=LMom1-IStGam+1
      Call IClear(ISLOp4,nmaxGm)
      Call PntLst
     $(Gam%NumGam,Momen1%Body(:LMom1),ISLOp4,'*',
     $nmaxGm,1,LMom1)

      Do i=1,Gam%NumGam
         Gam%GamG(i)%Title = Momen1%Body(ISLOp4(i)-1:ISLOp4(i)-1)
         Gam%GamG(i)%Label = Momen1%Body(ISLOp4(i):ISLOp4(i))
      End Do

      Read(IFileN,*)(Indx(i),i=1,2*(UVE%NumUVE+Gam%NumGam))
      If(IPrint.ge.0)
     $Write(6,*)(Indx(i),i=1,2*(UVE%NumUVE+Gam%NumGam))
      j=0
      Do i=1,UVE%NumUVE
         j=j+1
         UVE%UVEG(i)%Index(1) = Indx(j)
         j=j+1
         UVE%UVEG(i)%Index(2) = Indx(j)
      End Do
      Do i=1,Gam%NumGam
         j=j+1
         Gam%GamG(i)%Index(1) = Indx(j)
         j=j+1
         Gam%GamG(i)%Index(2) = Indx(j)
      End Do
      If(IPrint.ge.0) Call Write_UVE_Gam(6,UVE,Gam)
      Return
      End 
C############################################################
      Subroutine Write_UVE_Gam(NumFil,UVE,Gam)
      Use ModXpr
      Use ModMom
      Implicit None
      Type(UVFunction)             :: UVE
      Type(Gamma)                  :: Gam
      Type(List) Momen,Momen5,Momen6
      Type(List) MomExpToString
      Integer i,NumFil,j
      Integer,Dimension(nmaxGm+nmaxUV)    :: Indx

      Momen6%Length=0
      Do i=1,UVE%NumUVE
         Momen=MomExpToString(UVE%UVEG(i)%Argument)
         Momen5%Length = Momen%Length+1
         Momen5%Body(:Momen5%Length)=UVE%UVEG(i)%Title
     $   //Momen%Body(:Momen%Length)
         Momen6 = Momen6 * Momen5
      End Do
      Do i=1,Gam%NumGam
         Momen5%Length=2
         Momen5%Body(1:1)=Gam%GamG(i)%Title
         Momen5%Body(2:2)=Gam%GamG(i)%Label
         Momen6 = Momen6 * Momen5
      End Do
      If(Momen6%Length.eq.0) then
         Write(NumFil,*) 'x'
         Return
      Else
         Write(NumFil,*) Momen6%Body(:Momen6%Length)
      End If
      j=0
      Do i=1,UVE%NumUVE
         j=j+1
         Indx(j) = UVE%UVEG(i)%Index(1)
         j=j+1
         Indx(j) = UVE%UVEG(i)%Index(2)
      End Do
      Do i=1,Gam%NumGam
         j=j+1
         Indx(j) = Gam%GamG(i)%Index(1)
         j=j+1
         Indx(j) = Gam%GamG(i)%Index(2)
      End Do
      Write(NumFil,*)(Indx(i),i=1,j)
      Return
      End 
C############################################################
      Subroutine ExchangeOperators(B,ExpR,ITerms,j)
C     In expression A swap operators j-1 and j
C     If their commutator is non-zero then increment the size of
C     ExpR by one and add there the commutator
      Use ModXpr
      Implicit None
      Type(Expression)  :: A,B
      Type(Expression), Dimension(NumExp) :: ExpR
      TypE(One_Operator) Left,Right
      Integer ITerms,j
      Logical Electron_Creation, Electron_Destruction
      Logical Positron_Creation,Positron_Destruction
      Logical Photon_Creation,Photon_Destruction
      Logical Fermion_Operator
      Integer IPrint
      COMMON /Print/ IPrint

      A=B
      Left = A%Oper%OperG(j-1)
      Right= A%Oper%OperG(j)
 
      If( (Electron_Creation(Right).and.Electron_Destruction(Left))
     $.or.(Positron_Creation(Right).and.Positron_Destruction(Left))
     $.or.(Photon_Creation(Right).and.Photon_Destruction(Left))) then
         ITerms=ITerms+1
C        add a new expression at position ITerms
C        where pairing between operators is taken into account

         ExpR(ITerms) = A
         Call Cmmttr(j-1,j,ExpR(ITerms))

         If(IPrint.ge.5)
     $   Call Output(6,ExpR(ITerms),'After AddExp added term',
     $   ITerms)
      End If
      If(Fermion_Operator(Left).and.Fermion_Operator(Right))
     $A%IPowr(3)=A%IPowr(3)+2
      Call Swap_Oper(A%Oper%OperG(j-1),A%Oper%OperG(j))
      B = A
      Return
      End 
C############################################################
      Subroutine ExchangeOps(B,ExpR,ITerms,j)
C      In expression A swap operators j-1 and j
C      If their commutator is non-zero then increment the size of
C      ExpR by one and add there the commutator
         Use ModXpr
      Implicit None
      Type(Expression)  :: A,B
      Type(Expression), Dimension(NumExp) :: ExpR
      TypE(One_Operator) Left,Right
      Integer ITerms,j
      Logical Electron_Creation, Electron_Destruction
      Logical Positron_Creation,Positron_Destruction
      Logical Photon_Creation,Photon_Destruction
      Integer IPrint
      COMMON /Print/ IPrint

      A=B
      Left = A%Oper%OperG(j-1)
      Right= A%Oper%OperG(j)

      If( (Electron_Creation(Right).and.Electron_Destruction(Left))
     $.or.(Positron_Creation(Right).and.Positron_Destruction(Left))
     $.or.(Photon_Creation(Right).and.Photon_Destruction(Left))) then
         ITerms=ITerms+1
C        add a new expression at position ITerms
C        where pairing between operators is taken into account

         ExpR(ITerms) = A
         Call CmmtTm(j-1,j,ExpR(ITerms))

         If(IPrint.ge.5)
     $   Call Output(6,ExpR(ITerms),'After AddExp added term',
     $   ITerms)
      End If
      Call Swap_Oper(A%Oper%OperG(j-1),A%Oper%OperG(j))
      B = A
      Return
      End 
C############################################################
      Function Find_Largest_Xpr(B,k,IStaCr,ICurr,Mode)
      Use ModXpr
      Implicit None
      Type(Expression),Dimension(NumExp)   :: B
      Integer        :: k,i,IStart,IStaCr,ICurr,Mode
      Type(Expression) :: Current,Find_Largest_Xpr
      Logical GrTh3

      Current%IPowr(1) = 0
      Do i=IStaCr,ICurr
         If(B(i)%IPowr(1).eq.0) Cycle
         Current = B(i)
         k=i
         IStart=k+1
         Exit
      End Do

      Do i=IStart,ICurr
         If(B(i)%IPowr(1).eq.0) Cycle
         If((Mode.eq.0.and.GrTh1(B(i),Current))
     $   .or.Mode.eq.1.and.GrTh3(B(i),Current)) then
            Current=B(i)
            k=i
         End If
      End Do
      Find_Largest_Xpr=Current
      Return
      End 
C############################################################
      Subroutine Order_Bracket(A,IPowr)
      Use ModXpr
      Implicit None
      Type(Bracket)      :: A,C,B
      Integer, Dimension(NumPow)           ::  IPowr
      Integer k,m,ii
      Type(Energy) Find_Largest_Brk

      ii=0
      Do k=1,A%NumDen
         If(A%Denom(k)%NumO.eq.0) then
            Write(6,*) 'Warning!! Energy is zero!'
C           Leave this term for manual treatment
            Return
         End If
         ii=ii+1
         B%Denom(ii) = A%Denom(k)
      End Do
      B%NumDen=ii
      C%NumDen=ii
      Do k=1,B%NumDen
         C%Denom(k)=Find_Largest_Brk(B,m)
         B%Denom(m)%Energies(1)%Title='##'
      End Do
      Do k=1,C%NumDen
         If(C%Denom(k)%Sign.eq.-1) then
            C%Denom(k)%Sign = -C%Denom(k)%Sign
            IPowr(3) = IPowr(3) + 2
         End If
      End Do
      A = C
      Return
      End
C############################################################
      Subroutine Delta_Product(A,ExpR)
C     Product of 2 delta functions
      Use ModXpr
      Use ModDNT
      Implicit None
      Type(MomExp),Intent(In)      :: A
      Type(Expression)             :: ExpR
      Integer NumDel,Kill_Delta,IDummy

C      If(A%Length.eq.0.and.B%Length.eq.0) then
C         ExpR%Delta%Length=0
C      Else If(A%Length.gt.0.and.B%Length.eq.0) then
C         ExpR%Delta = A
         IDummy = Kill_Delta(ExpR,A,1)
C      Else If(A%Length.eq.0.and.B%Length.gt.0) then
C         ExpR%Delta = B
C         IDummy = Kill_Delta(ExpR,B,0)
C      Else If(A%Length.gt.0.and.B%Length.gt.0) then
C         NumDel = 2
C         IDummy = Kill_Delta(ExpR,A,0)
C         If(IDummy.eq.1) then
C            NumDel=NumDel-1
C            ExpR%Delta = B
C            If(Kill_Delta(ExpR,B,0).eq.1) then
C               NumDel=NumDel-1
C               ExpR%Delta%Length = 0
C            End If
C         Else If(IDummy.eq.0) then
C            If(Kill_Delta(ExpR,B,0).eq.1) then
C               NumDel=NumDel-1
C               ExpR%Delta = A
C            End If
C         End If
C         If(NumDel.gt.1)
C     *    Write(6,*)'Warning!!! Cannot deal with two deltas'
C      End If
      Return
      End
C############################################################
      Function Kill_Delta(ExpR,A,Mode)
C     Integrate ExpR with delta function of A
C     Returns 1 if delta-function was killed
C             0 if not killed
C     Mode ... 0 kill delta only if time dependence retained
C          ... 1 kill delta in any event (not if Denom becomes zero)
      Use ModXpr
      Use ModDNT
      Implicit None
      Type(MomExp)      :: A
      Type(Expression)             :: ExpR
      Type(MomExp)                      :: Zero,To,Is
      Type(Momentum) From

      Integer ChkDlt,Kill_Delta,Mode,IDummy

      Kill_Delta = 0

C     Find the momentum in Momen2 that does not belong to
C     DoNotT (From)
      Is = A
      From=VarOKToChange(Is)
      Zero%Length=0
      Call MakeFromTo(Is,Zero,From,To)

C     First check that applying delta-function to the exponent
C     won't make exponent time-independent
      IDummy = ChkDlt(ExpR,From,To)
      
      If(IDummy.eq.0.or.(Mode.eq.1.and.IDummy.eq.1)) then
C        IDummy.eq.0 ... we can safely kill delta-function
C        IDummy.eq.1 ... killing delta-function will eliminate
C                        time-dependence, OK if Mode.eq.1.
C        Now we substitute everywhere To instead of From
         Call ChangeVariablesExpR(ExpR,From,To)
         Kill_Delta = 1
      Else If(IDummy.eq.2) then
C        Killing delta-function will make zero denominator
         Return
      End If

      Return
      End

